"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarDays = exports.WeekDaysLong = exports.WeekDaysShort = void 0;
const react_1 = __importDefault(require("react"));
const Calendar_1 = require("./Calendar");
exports.WeekDaysShort = ['po', 'út', 'st', 'čt', 'pá', 'so', 'ne'];
exports.WeekDaysLong = ['pondělí', 'úterý', 'středa', 'čtvrtek', 'pátek', 'sobota', 'neděle'];
const CalendarDays = ({ workDate, layout, longDayNames }) => {
    const dayOfWeek = new Date(workDate).getDay() - 1 || 6;
    let daysInWeekNames = exports.WeekDaysShort;
    if (longDayNames)
        daysInWeekNames = exports.WeekDaysLong;
    if (layout === Calendar_1.CalendarLayoutEnum.day)
        daysInWeekNames = [exports.WeekDaysLong[dayOfWeek]];
    return (react_1.default.createElement("div", { className: "calendar-row calendar-days table-row" }, daysInWeekNames.map((day) => (react_1.default.createElement("div", { className: "calendar-cell table-cell", key: day }, day)))));
};
exports.CalendarDays = CalendarDays;
