"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WeekDayView = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const date_fns_1 = require("date-fns");
const utils_1 = require("../utils");
const Calendar_1 = require("./Calendar");
const CalendarCell_1 = require("./CalendarCell");
function WeekDayView(props) {
    const { layout, View, enableHover, onClick, workDate, weekOfMonth, borderCollapse, value, enableBorder, selected, type, } = props;
    const getStartOf = () => {
        if (layout === Calendar_1.CalendarLayoutEnum.day)
            return workDate;
        const startOf = layout === Calendar_1.CalendarLayoutEnum.month ? (0, date_fns_1.setDate)(workDate, 1) : workDate;
        return (0, utils_1.calcStartOf)(startOf, weekOfMonth);
    };
    const renderDays = (0, react_1.useMemo)(() => {
        const startOf = getStartOf();
        const columns = layout === Calendar_1.CalendarLayoutEnum.day ? 1 : 7;
        return (0, ramda_1.range)(0, columns).map((dayOfWeek) => {
            const date = (0, date_fns_1.addDays)(startOf, dayOfWeek++);
            const props = Object.assign({ date, isToday: (0, date_fns_1.isSameDay)(date, new Date()), workDate, hover: layout === Calendar_1.CalendarLayoutEnum.day ? false : enableHover, onClick,
                layout,
                dayOfWeek, children: date.getDate(), weekOfMonth,
                enableBorder,
                enableHover,
                type }, (type === Calendar_1.CalendarTypeEnum.weeks
                ? {
                    borderCollapse: true,
                    isSelected: selected ? (0, date_fns_1.isSameWeek)(date, selected, { weekStartsOn: 1 }) : false,
                }
                : { borderCollapse, isSelected: selected ? (0, date_fns_1.isSameDay)(date, selected) : false }));
            return View ? react_1.default.createElement(View, Object.assign({ key: date.getTime() }, props)) : react_1.default.createElement(CalendarCell_1.CalendarCell, Object.assign({ key: date.getTime() }, props));
        });
    }, [workDate, View, layout, borderCollapse, weekOfMonth, value, enableHover, enableBorder, selected, type]);
    return react_1.default.createElement(react_1.default.Fragment, null, renderDays);
}
exports.WeekDayView = WeekDayView;
