"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const react_1 = __importDefault(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const common_1 = require("@procyon/types/common");
const Button = (props) => {
    const { disabled, onClick, status = common_1.StatusEnum.none, label, type = 'button', className, blank = false } = props;
    const handleOnClick = () => {
        if (onClick) {
            setTimeout(() => {
                onClick();
            }, 100);
        }
    };
    return (react_1.default.createElement("button", { className: (0, clsx_1.default)('button', {
            'button--blank': blank,
            'button--none': status === common_1.StatusEnum.none,
            'button--info': status === common_1.StatusEnum.info,
            'button--success': status === common_1.StatusEnum.success,
            'button--warning': status === common_1.StatusEnum.warning,
            'button--error': status === common_1.StatusEnum.error,
        }, className), onClick: handleOnClick, disabled: disabled, type: type }, label));
};
exports.Button = Button;
