"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HumanVerify = void 0;
const react_1 = __importStar(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const message_1 = require("@procyon/localization/message");
const calcOffset = (el) => {
    const rect = el.getBoundingClientRect(), scrollLeft = window.scrollX || document.documentElement.scrollLeft, scrollTop = window.scrollY || document.documentElement.scrollTop;
    return {
        top: rect.top + scrollTop,
        left: rect.left + scrollLeft,
    };
};
const HumanVerify = ({ onVerified, label }) => {
    const [isBot, setIsBot] = (0, react_1.useState)(true);
    const wrapperRef = (0, react_1.useRef)(null);
    const sliderRef = (0, react_1.useRef)(null);
    const handleMove = (e) => {
        if (!wrapperRef.current || !sliderRef.current) {
            return;
        }
        if (!isBot) {
            return;
        }
        const pageX = e.pageX || e.changedTouches[0].pageX;
        const wrapperOffset = calcOffset(wrapperRef.current);
        let left = pageX - wrapperOffset.left - sliderRef.current.offsetWidth / 2;
        const maxRight = wrapperRef.current.offsetWidth - sliderRef.current.offsetWidth - 4;
        if (left <= 0) {
            left = 0;
        }
        else if (left >= maxRight) {
            left = maxRight;
        }
        sliderRef.current.style.left = left + 'px';
        if (left === maxRight) {
            setIsBot(false);
            onVerified();
        }
    };
    (0, react_1.useEffect)(() => {
        var _a, _b;
        const onMouseDownListener = () => {
            var _a;
            (_a = sliderRef.current) === null || _a === void 0 ? void 0 : _a.addEventListener('mousemove', handleMove);
        };
        const onMouseUpListener = () => {
            var _a;
            (_a = sliderRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('mousemove', handleMove);
        };
        (_a = sliderRef.current) === null || _a === void 0 ? void 0 : _a.addEventListener('mousedown', onMouseDownListener);
        (_b = sliderRef.current) === null || _b === void 0 ? void 0 : _b.addEventListener('touchmove', handleMove);
        document.addEventListener('mouseup', onMouseUpListener);
        return () => {
            var _a, _b, _c;
            (_a = sliderRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('mousemove', handleMove);
            (_b = sliderRef.current) === null || _b === void 0 ? void 0 : _b.removeEventListener('touchmove', handleMove);
            (_c = sliderRef.current) === null || _c === void 0 ? void 0 : _c.removeEventListener('mousedown', onMouseDownListener);
            document.removeEventListener('mouseup', onMouseUpListener);
        };
    }, [sliderRef.current]);
    return (react_1.default.createElement("div", { className: "field-container humanverify-container" },
        label && react_1.default.createElement("label", { className: "field-label mr-2" }, label),
        react_1.default.createElement("div", { ref: wrapperRef, className: "hv-wrapper", style: {
                '--hv-slider-content-before': `"${(0, message_1.t)('procyon.common.yes')}"`,
                '--hv-slider-content-after': `"${(0, message_1.t)('procyon.common.no')}"`,
            } },
            react_1.default.createElement("div", { ref: sliderRef, className: (0, clsx_1.default)('hv-slider', { 'hv-slider--ok': !isBot }) }))));
};
exports.HumanVerify = HumanVerify;
