"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const common_1 = require("@procyon/types/common");
const CheckCircle_1 = __importDefault(require("./Icons/CheckCircle"));
const ExclamationCircle_1 = __importDefault(require("./Icons/ExclamationCircle"));
const ExclamationTriangle_1 = __importDefault(require("./Icons/ExclamationTriangle"));
const HappyMessage_1 = __importDefault(require("./Icons/HappyMessage"));
const InfoCircle_1 = __importDefault(require("./Icons/InfoCircle"));
function Message(props) {
    const { status = common_1.StatusEnum.none, title, children } = props;
    return (react_1.default.createElement("div", { className: (0, clsx_1.default)('message', {
            'message--none': status === common_1.StatusEnum.none,
            'message--info': status === common_1.StatusEnum.info,
            'message--success': status === common_1.StatusEnum.success,
            'message--warning': status === common_1.StatusEnum.warning,
            'message--error': status === common_1.StatusEnum.error,
        }) },
        react_1.default.createElement("div", { className: "text-3xl" },
            react_1.default.createElement("div", null,
                status === common_1.StatusEnum.info && react_1.default.createElement(InfoCircle_1.default, null),
                status === common_1.StatusEnum.success && react_1.default.createElement(CheckCircle_1.default, null),
                status === common_1.StatusEnum.warning && react_1.default.createElement(ExclamationTriangle_1.default, null),
                status === common_1.StatusEnum.error && react_1.default.createElement(ExclamationCircle_1.default, null),
                status === common_1.StatusEnum.none && react_1.default.createElement(HappyMessage_1.default, null))),
        react_1.default.createElement("div", { className: "text-lg max-w-full flex-initial" },
            react_1.default.createElement("div", null,
                title,
                react_1.default.createElement("div", { className: "text-sm" }, children)))));
}
exports.default = Message;
