"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Skeleton = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const clsx_1 = __importDefault(require("clsx"));
const wouter_1 = require("wouter");
const Menu_1 = __importDefault(require("@procyon/components/Icons/Menu"));
const RightToBracket_1 = __importDefault(require("@procyon/components/Icons/RightToBracket"));
const Modals_1 = __importDefault(require("@procyon/components/Modal/components/Modals"));
const Toaster_1 = require("@procyon/components/Toaster");
const Toasters_1 = require("@procyon/components/Toaster/components/Toasters");
const useMediaQuery_1 = require("@procyon/hooks/useMediaQuery");
const utils_1 = require("@procyon/utils");
const Item_1 = require("./Item");
const Skeleton = (props) => {
    const { children, components = {}, items, toasterPosition = Toasters_1.ToastersPosition.TopRight } = props;
    const { footer } = components;
    const [, setLocation] = (0, wouter_1.useLocation)();
    const enabledSide = !(0, utils_1.isNilOrEmpty)(items === null || items === void 0 ? void 0 : items.side);
    const enabledTop = !(0, utils_1.isNilOrEmpty)(items === null || items === void 0 ? void 0 : items.top) || !(0, utils_1.isNilOrEmpty)(items === null || items === void 0 ? void 0 : items.user) || !(0, utils_1.isNilOrEmpty)(items === null || items === void 0 ? void 0 : items.logo);
    const { isMaxMatch: isMobile } = (0, useMediaQuery_1.useMediaQuery)({ size: useMediaQuery_1.SIZES.md });
    const { isMaxMatch: isTablet } = (0, useMediaQuery_1.useMediaQuery)({ size: useMediaQuery_1.SIZES.lg });
    const [sideCollapsed, setSideCollapsed] = (0, react_1.useState)(isMobile || isTablet);
    const [topCollapsed, setTopCollapsed] = (0, react_1.useState)(isMobile);
    (0, react_1.useEffect)(() => {
        setSideCollapsed(isMobile || isTablet);
        setTopCollapsed(isMobile);
    }, [isMobile, isTablet]);
    const toggleSide = () => {
        setSideCollapsed(!sideCollapsed);
    };
    const toggleTop = () => {
        setTopCollapsed(!topCollapsed);
    };
    const openLink = ({ href, external, onClick }) => {
        if (!(0, ramda_1.isNil)(onClick)) {
            onClick();
        }
        else {
            if (external) {
                window.open(href, '_blank');
            }
            else if (href) {
                setLocation(href);
            }
        }
    };
    const topItems = (0, react_1.useMemo)(() => {
        var _a;
        return (_a = items === null || items === void 0 ? void 0 : items.top) === null || _a === void 0 ? void 0 : _a.map((item, i) => { var _a; return react_1.default.createElement(Item_1.Item, { key: (_a = item.href) !== null && _a !== void 0 ? _a : i, onClick: openLink, item: item }); });
    }, [items === null || items === void 0 ? void 0 : items.top]);
    const userItems = (0, react_1.useMemo)(() => {
        var _a;
        return (_a = items === null || items === void 0 ? void 0 : items.user) === null || _a === void 0 ? void 0 : _a.map((item, i) => { var _a; return react_1.default.createElement(Item_1.Item, { key: (_a = item.href) !== null && _a !== void 0 ? _a : i, onClick: openLink, item: item }); });
    }, [items === null || items === void 0 ? void 0 : items.user]);
    const sideItems = (0, react_1.useMemo)(() => {
        var _a;
        return (_a = items === null || items === void 0 ? void 0 : items.side) === null || _a === void 0 ? void 0 : _a.map((item, i) => {
            var _a;
            return (react_1.default.createElement(Item_1.Item, { key: (_a = item.href) !== null && _a !== void 0 ? _a : i, onClick: openLink, item: item, collapsed: sideCollapsed }));
        });
    }, [items === null || items === void 0 ? void 0 : items.side, sideCollapsed]);
    return (react_1.default.createElement("div", { className: "page" },
        enabledTop && (react_1.default.createElement("div", { className: "page-top" },
            react_1.default.createElement("div", { className: "page-top-content" },
                react_1.default.createElement("div", { className: "page-top-control" },
                    (items === null || items === void 0 ? void 0 : items.logo) && react_1.default.createElement("div", { className: "page-top-logo" }, items === null || items === void 0 ? void 0 : items.logo),
                    isMobile && react_1.default.createElement(Menu_1.default, { className: "page-top-toggler", onClick: toggleTop })),
                !topCollapsed && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement("div", { className: "ml-auto" }),
                    topItems,
                    react_1.default.createElement("div", { className: "ml-auto" }),
                    userItems))))),
        react_1.default.createElement("div", { className: (0, clsx_1.default)('page-main', { flex: enabledSide }) },
            enabledSide && (react_1.default.createElement("div", { className: (0, clsx_1.default)('side', {
                    'side--collapsed': sideCollapsed,
                    'side--expand': !sideCollapsed,
                }) },
                react_1.default.createElement(RightToBracket_1.default, { className: (0, clsx_1.default)('side-toggler', { 'rotate-180': !sideCollapsed }), onClick: toggleSide }),
                sideItems)),
            react_1.default.createElement("div", { className: "content" }, children)),
        react_1.default.createElement("div", { className: "mt-4" }, footer),
        react_1.default.createElement(Modals_1.default, null),
        react_1.default.createElement(Toaster_1.Toasters, { position: toasterPosition })));
};
exports.Skeleton = Skeleton;
